<template>
  <v-container :fluid="true" class="d-flex justify-center align-center fill-height">
    <div class="bg-image"></div>
    <v-row>
      <v-col cols="12">
        <div class="d-flex justify-center align-center flex-column text-center">
          <v-card
              class="pa-6 rounded" min-width="400" max-width="550">
            <v-img
                min-width="100" width="100" contain class="shrink mx-auto"
                src="@/assets/images/logo/logo-blue.png" alt="Vetvite logo"
            />
            <v-card-title class="text-center d-block">Confirmer mon compte</v-card-title>

            <v-alert id="errorAlert" class="d-none justify-center white--text font-weight-bold" color="error" text></v-alert>
            <v-alert id="emailAlert" class="d-none justify-center white--text" color="primary" text></v-alert>
            <v-alert id="successAlert" :class="'d-none text-center flex-column ' + (hideForm ? 'd-flex' : '')" color="primary">
              <p class="white--text">Votre compte à bien été confirmé !</p>
              <router-link :to="{name: 'Home'}" class="text-decoration-none" v-show="hideForm">
                <v-btn color="white" small>Continuer
                  <v-icon right small>mdi-arrow-right-circle</v-icon>
                </v-btn>
              </router-link>
            </v-alert>

            <v-form ref="form" @submit.prevent="confirm" v-model="isValid" v-show="!hideForm">
              <p class="text--darken-3 mb-0">
                Nous venons de vous envoyer un code de vérification par email, merci de le saisir ci-dessous.
              </p>
              <div class="my-5">
                <VerificationCodeInput v-on:complete="onComplete" :fields="5"/>
              </div>
              <div>
                <v-btn depressed type="submit" color="primary" full-width :loading="loading"
                       :disabled="loading || !isValid">
                  Vérifier mon compte
                  <v-icon right dark>mdi-check-circle-outline</v-icon>
                </v-btn>
              </div>
              <div class="text--lighten-3 mt-2">
                <small>
                  <v-btn text x-small color="secondary" light @click="resendModal.dialog = true">Me renvoyer un code ?
                  </v-btn>
                </small>
              </div>
            </v-form>
          </v-card>
        </div>
      </v-col>
    </v-row>

    <v-dialog v-model="resendModal.dialog" max-width="500px">
      <v-card class="py-2">
        <v-card-title class="headline my-4 text-center">
          Renvoyer un code de confirmation par email ?
        </v-card-title>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" text @click="resendModal.dialog = false">Annuler</v-btn>
          <v-btn color="error" text @click="resendEmail" :loading="resendModal.loading" :disabled="resendModal.loading">
            Renvoyer
          </v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>

  </v-container>
</template>

<script>

import VerificationCodeInput from "../../components/VerificationCodeInput";
import Vue from "vue";
import {mapGetters} from "vuex";

export default {
  name: 'ConfirmationRegistration',
  components: {VerificationCodeInput},
  data() {
    return {
      loading: false,
      isValid: false,
      terminate: false,
      resendModal: {
        dialog: false,
        loading: false,
      }
    }
  },
  computed: {
    ...mapGetters(['user', 'isVerified']),
    hideForm() {
      return this.isVerified || this.terminate;
    },
  },
  methods: {
    onComplete(value, reset) {

      this.loading = true;

      let errorAlert = document.getElementById('errorAlert');
      let successAlert = document.getElementById('successAlert');
      let emailAlert = document.getElementById('emailAlert');

      errorAlert.classList.remove('d-flex');
      successAlert.classList.remove('d-flex');
      emailAlert.classList.remove('d-flex');

      Vue.prototype.$apiRest.post('/user/confirm', {code: value}).
      then((res) => {
        successAlert.classList.add('d-flex');
        this.$store.commit('UPDATE_USER_PROPS', {property: 'enabled', value: res.data.newState})
        this.terminate = true;
      }).catch(err => {
        errorAlert.innerHTML = err.response ? (err.response.data ? err.response.data : err.response) : err;
        errorAlert.classList.add('d-flex');
      }).finally(() => {
        this.loading = false
        reset()
      })
    },
    confirm() {
      let code = "";
      document.querySelectorAll('.code-input input').forEach((input) => {
        code += input.value;
      });
      this.onComplete(code)
    },
    resendEmail() {

      this.resendModal.loading = true;

      let errorAlert = document.getElementById('errorAlert');
      let successAlert = document.getElementById('emailAlert');

      errorAlert.classList.remove('d-flex');
      successAlert.classList.remove('d-flex');

      Vue.prototype.$apiRest.post('/user/sendconfirm', {}).then(() => {
        successAlert.innerHTML = `Un nouveau code vient d'être envoyé à <b>${this.user.email}</b>`
        successAlert.classList.add('d-flex');
      }).catch(err => {
        errorAlert.innerHTML = err.response ? (err.response.data ? err.response.data : err.response) : err;
        errorAlert.classList.add('d-flex');
      }).finally(() => {
        this.resendModal.dialog = false
        this.resendModal.loading = false
      })
    }
  }
}
</script>

<style scoped>
@-moz-keyframes loader {
  from {
    transform: rotate(0);
  }
  to {
    transform: rotate(360deg);
  }
}

@-webkit-keyframes loader {
  from {
    transform: rotate(0);
  }
  to {
    transform: rotate(360deg);
  }
}

@-o-keyframes loader {
  from {
    transform: rotate(0);
  }
  to {
    transform: rotate(360deg);
  }
}

@keyframes loader {
  from {
    transform: rotate(0);
  }
  to {
    transform: rotate(360deg);
  }
}
</style>
